<?php
  $durations = array(
    array('max' => 30, 'text' => '0s - 30s', 'num' => 0),
    array('max' => 60, 'text' => '30s - 1min', 'num' => 0),
    array('max' => 120, 'text' => '1min - 2min', 'num' => 0),
    array('max' => 180, 'text' => '2min - 3min', 'num' => 0),
    array('max' => 240, 'text' => '3min - 4min', 'num' => 0),
    array('max' => 300, 'text' => '4min - 5min', 'num' => 0),
    array('max' => 600, 'text' => '5min - 10min', 'num' => 0),
    array('max' => 900, 'text' => '10min - 15min', 'num' => 0),
    array('max' => 1800, 'text' => '15min - 30min', 'num' => 0),
    array('max' => 2700, 'text' => '30min - 45min', 'num' => 0),
    array('max' => 3600, 'text' => '45min - 1h', 'num' => 0),
    array('max' => 0, 'text' => '1h+', 'num' => 0)
  );
  $visits = array();
  $f = @fopen(GSDATAOTHERPATH . HITCOUNT_DIR . 'log.txt', "r");
  if ($f) {
    while (($line = fgets($f)) !== false) {
      $parts = preg_split('/ /', $line, 5);
      $ti = (int) $parts[0];
      $vi = $parts[1];
      if (!isset($visits[$vi])) {
        $visits[$vi] = array('start' => $ti, 'duration' => 0);
      } else {
        $visits[$vi]['duration'] = $ti - $visits[$vi]['start'];
      }
    }
    fclose($f);
  }
  if (count($visits) > 0) {
    foreach ($visits as $visit) {
      $i = 0; while ($durations[$i]['max'] > 0 && $durations[$i]['max'] < $visit['duration']) $i++;
      $durations[$i]['num']++;
    }
  }
	$max = 0;
	foreach ($durations as $du) if ($du['num'] > $max) $max = $du['num'];
?>
  <label>Visit durations</label><?php hitcount_show_links('duration'); ?>
  <table id="useragents" class="edittable highlight">
    <tr><th>Duration</th><th style="width:10%">Visitors</th></tr>
<?php foreach ($durations as $du) { ?>
    <tr><td><?php echo $du['text']; ?></td><td style="width:10%;text-align:right"><?php hitcount_show_amount($du['num'],$max); ?></td></tr>
<?php } ?>
  </table>


