<?php
function hitcount_cmp_ua($a, $b) {
  if (count($a['visitors']) != count($b['visitors'])) {
    return count($b['visitors']) - count($a['visitors']);
  } else if ($a['hits'] != $b['hits']) {
    return $b['hits'] - $a['hits'];
  } else {  
    return strcmp($a['name'],$b['name']);
  }  
}
include(GSPLUGINPATH.'hitcount/useragent_info.php');

  $useragents = array();
  $f = @fopen(GSDATAOTHERPATH . HITCOUNT_DIR . 'log.txt', "r");
  if ($f) {
    while (($line = fgets($f)) !== false) {
      $parts = preg_split('/ /', $line, 5);
      $ua = $parts[4];
      $vi = $parts[1];
      if (!isset($useragents[$ua])) {
        $isRobot = preg_match('/bot|spider|crawler|curl|slurp|^$/i', $ua);
        $useragents[$ua] = array('name' => $ua, 'hits' => 1, 'visitors' => array($vi), 'robot' => $isRobot);
        if (!$isRobot) {
          $browser = ua_get_browser($ua);
          $useragents[$ua]['browser'] = $browser[0];
          $useragents[$ua]['browserversion'] = $browser[1];
          $os = ua_get_os($ua);
          $useragents[$ua]['os'] = $os[0];
          $useragents[$ua]['osversion'] = $os[1];
        }
      } else {
        $useragents[$ua]['hits']++;
        if (!in_array($vi, $useragents[$ua]['visitors'])) $useragents[$ua]['visitors'][] = $vi;
      }
    }
    fclose($f);
  }
	$maxhi = 0;
	$maxvi = 0;
	if (count($useragents) > 0) foreach ($useragents as &$ua) {
		if ($ua['hits'] > $maxhi) $maxhi = $ua['hits'];
		if (count($ua['visitors']) > $maxvi) $maxvi = count($ua['visitors']);
	}
  usort($useragents,'hitcount_cmp_ua');
?>
  <label>User agents</label><?php hitcount_show_links('useragents'); ?>
  <table id="useragents" class="edittable highlight">
    <tr><th>User agent</th><th>Browser</th><th>OS</th><th style="width:10%">Hits</th><th style="width:10%">Visitors</th></tr>
<?php if (count($useragents) > 0) foreach ($useragents as &$ua) { ?>
    <tr>
			<td <?php echo $ua['robot'] ? 'style="color:#888888"' : ''; ?>><?php echo htmlspecialchars($ua['name']); ?></td>
      <td><?php echo @htmlspecialchars($ua['browser']/*.' '.$ua['browserversion']*/); ?></td>
      <td><?php echo @htmlspecialchars($ua['os'].' '.$ua['osversion']); ?></td>
			<td style="width:10%;text-align:right"><?php hitcount_show_amount($ua['hits'],$maxhi); ?></td>
			<td style="width:10%;text-align:right"><?php hitcount_show_amount(count($ua['visitors']),$maxvi); ?></td>
		</tr>
<?php } ?>
  </table>

